(module
  os
  ;(option (loadq "common.sch"))
  (include "./common.sch")
  (type (subtype string* "char**" (cobj))
        (coerce cobj string* () (cobj->string*))
        (coerce string* cobj () (string*->cobj))
        (coerce
          string*
          bool
          ()
          ((lambda (x) (pragma::bool "$1 != NULL" x))))
        (subtype bstring* "obj_t" (obj))
        (coerce obj bstring* () ())
        (coerce bstring* obj () ())
        (coerce
          bstring*
          string*
          (string*?)
          (bstring*->string*))
        (coerce
          string*
          obj
          ()
          ((lambda
             (result)
             (pragma::bstring*
               "cobj_to_foreign($1, $2)"
               'string*
               result)))))
  (foreign
    (macro string* cobj->string* (cobj) "(char**)")
    (macro cobj string*->cobj (string*) "(long)")
    (macro string*
           bstring*->string*
           (foreign)
           "(char**)FOREIGN_TO_COBJ"))
  (export 
    (string*?::bool o::obj)
    (string*->string-list::pair-nil sp::string* #!optional len)
    (rdbms-format::bstring statement::bstring bindings::pair-nil)
    (string->dbstring::bstring s::bstring)
    )
)
  
(define
  (string*?::bool o::obj)
  (and (foreign? o) (eq? (foreign-id o) 'string*)))

(define (string*->string-list::pair-nil sp::string* #!optional len)
  ((cpointer->list string) sp len))

(define (string->dbstring::bstring s::bstring)
  (let*((is(open-input-string s))
	(os(open-output-string)))
    (let loop()
      (let((ch(read-char is)))
	(if(eof-object? ch)
	   (get-output-string os)
	   (begin
	     (case ch
	       ((#\" #\' #\\)
		(write-char #\\ os)
		(write-char ch os))
	       ((#a000)
		(write-char #\\ os)
		(write-char #\0 os))
	       (else
		(write-char ch os)))
	     (loop)))))))


(define (string-grammar-apply s get-char)
  (let((os (open-output-string))
       (is (open-input-string s)))
    (let loop()
      (let((c (get-char is)))
	(if (eof-object? c)
	    (close-output-port os)
	    (begin
	      (display c os)
	      (loop)))))))

(define (rdbms-format statement bindings)
  (string-grammar-apply
   statement
   (regular-grammar
    ()
    ((: #\: (submatch(+ digit)))
     (let((bind-no(string->integer(the-submatch 1))))
       (check-range
	(when(>fx bind-no(length bindings))
	     (error "bind!" "bind position out of range"bind-no)))
       (let((arg(list-ref bindings(-fx bind-no 1))))
	 (cond
	  ((eq? arg #unspecified) "NULL")
;	  ((tm? arg)
;	   (strftime arg "%Y%m%d%H%M%S"))
	  ((or(string? arg)(symbol? arg))
	   (format "'~a'" (string->dbstring arg)))
	  (else arg))))))))
